////////////////////////////////////////////////////////////////////
//Shooting demo
//Authour:Joseph -www.dantom.com-
//compiled with version 322
////////////////////////////////////////////////////////////////////

#include <dm uti>              //utility include
#define BULLET_MAX	6

var sprite/g_heroShip
var sprite/g_heroBulletCounter
var g_heroShipX			=		1;
var g_heroShipY			= 	50;
var g_heroShipwidth=	32;
var g_heroShipheight=16;
var g_heroBulletwidth=8;
var g_heroBulletheight=8;
var g_heroBullets[BULLET_MAX];
var g_newFrame				=		1;
var g_bulletsFired=		0;
var g_sleep=1
var g_heroBulletSpeed	=5;
proc/binInput(client/client)
{
	g_heroShip=uti_create_sprite('heroship.dmi',
																														void,
																													)
	uti_SetSprite(g_heroShip,																													//sprite
															g_heroShipX,																												//x
															g_heroShipY,																												//y
															client,																																	//screen
															0,																																						//clone?
															);
	uti_drawText("0",												//text
														1+(18*8),							//x
														160-8,										//y
														client,									//tag
														0,														//delay
														0,														//ping
														"g_counter",				//tag
														MOB_LAYER+0.1			//layer
														);
	uti_drawText("bullets remaining:",																//text
														1,																																			//x
														160-8,																															//y
														client,																														//screen
														0																																				//delay
														);
	g_heroBulletCounter=locate("g_counter");
	while(TRUE)
	{
		g_sleep++
		if(g_newFrame)
		{
			queryKeys(client);
			redrawShip(client);
		};
		sleep(1)
		//sleep((g_sleep%2)?0:1)
	};
	return (0);
};

proc/redrawShip(client/client)
{
	g_heroBulletCounter.icon_state=num2text(BULLET_MAX-g_bulletsFired)
	uti_SetSprite(g_heroShip,							//sprite number moving
															g_heroShipX,						//sprite X
															g_heroShipY,						//sprite Y
															client,											//screen
															0,																//clone?
															MOB_LAYER+0.1,				//layer
														)
};

proc/start_path(sprite_number,client/client)
{
	var/sprite/bullet=g_heroBullets[sprite_number]
	var g_sleep=1
	if(!bullet)return (0)
	spawn while(bullet)
	{
		if(bullet.px+g_heroBulletwidth+g_heroBulletSpeed<256+g_heroBulletwidth)
			bullet.px+=g_heroBulletSpeed;
			uti_SetSprite(bullet,
																	bullet.px,
																	bullet.py,
																	client,
																	0,
																	);
		else
		{
			g_heroBullets[sprite_number]=void
			g_bulletsFired--;
			del(bullet)
		};
		sleep((g_sleep	%2)?1:0)
	};
};
proc/queryKeys(client/client)
{
	if(client.uti_UP_PRESSED)
	{
		if(g_heroShipY+g_heroShipheight+1<160)g_heroShipY++
		return (0);
	};
	if(client.uti_DOWN_PRESSED)
	{
		if(g_heroShipY-1>1)g_heroShipY--
		return (0);
	};
	if(client.uti_CENTER_PRESSED)
	{
		var i;
		if(BULLET_MAX-g_bulletsFired>0)
		{
			g_bulletsFired++
			for(i=1;i<BULLET_MAX+1;i++)
			{
				if(!g_heroBullets[i])
				{
					g_heroBullets[i]=uti_create_sprite('herobullet.dmi',
																																								void,
																																							);
					uti_SetSprite(g_heroBullets[i],
																			g_heroShipX+g_heroShipwidth-g_heroBulletwidth+g_heroBulletSpeed,
																			g_heroShipY-4,
																			client,
																			0,
																			)
					start_path(i,client);
					return
				};
			};
		};
	};
};
/world/New(void)
{
	uti_InitCharset(void,rgb(255,138,138))
};
client/New(void)
{
	..(void)
	binInput(src)
};

